#!/usr/bin/perl 
# BLASTER v1.00 - A free GPL'd IRC service for IRC operators. 
# Copyright (c) 2002 Antoine Kalmbach <anzu@mbnet.fi>
# $Id: blaster.pl,v 1.3 2002/06/16 13:42:40 anzuhan Exp $

my $version = "1.10"; # DON'T touch

use strict;
use POE::Component::IRC;
use POE;

my $startnick = 'Blaster'; # normal users cannot use single letter nicks
my $nick = 'B';
my $username = 'blaster';
my $operuser = 'blaster';
my $operpass = 'fuckoff';
my $server = 'irc.somenet.org';
my $hostname = 'blaster.somenet.org';
my $operident = 'blaster';
my $channel = '#opers';
my $blastmsg = 'Blasted!';


sub _start {
   my $kernel = $_[KERNEL];
    
   $kernel->alias_set('blastmaster');
   $kernel->post('blaster', 'register', 'all');
   $kernel->post('blaster', 'connect', { Debug => 1,
                                         Nick => $startnick,
                                         Server => $server,
         				 Port => '6667', 
                                         Username => $username,
            				 Ircname => 'This is Blaster v'.$version,
                                       }
   );
}

sub irc_001 {
   my $kernel = $_[KERNEL];
  
   $kernel->post('blaster', 'oper', $operuser, $operpass);
   $kernel->post('blaster', 'nick', $nick);
   $kernel->post('blaster', 'mode', $nick, '+kd-wsg');
}

sub irc_376 {
 
   my $kernel = $_[KERNEL];
 
   $kernel->post('blaster','sl', 'sethost '.$operident.' '.$hostname);
   $kernel->post('blaster','join', $channel);
}

sub irc_353 {
   my ($kernel, $chan) = @_[KERNEL, ARG2];
   
   $kernel->post('blaster','sl', 'servmode '.$channel.' +o '.$nick);
}


sub irc_disconnected {
   my $server = $_[ARG0];
  
   print "Connection lost to $server\n";
}

sub irc_error {
   my $error = $_[ARG0];
   
   print "Error occured: $error\n";
}

sub irc_socketerr {
   my $error = $_[ASRG0];
  
   print "Could not establish connection. Reason: $error";
}

sub _stop { 
   my $kernel = $_[KERNEL];
 
   $kernel->post('blaster', 'sl', 'quit Terminated.');
   print "Connection stopped.\n";
}

sub irc_ctcp_version {
   my ($kernel, $who, $recipient, $msg) = @_[KERNEL, ARG0 .. ARG2];
   $who =~ s/^(.*)!.*$/$1/;

   $kernel->post('blaster', 'ctcpreply', $who, 'VERSION Blaster v'.$version.' by Antoine Kalmbach (anzu@mbnet.fi)');
}

sub irc_msg {
   my $foo;
   my ($kernel, $who, $where, $msg) = @_[KERNEL, ARG0 .. ARG2];
   $who =~ s/^(.*)!.*$/$1/;
   if($msg =~ /help/) {
      $kernel->post('blaster', 'privmsg', $who, 'Help for Blaster');
      $kernel->post('blaster', 'privmsg', $who, '----------------');
      $kernel->post('blaster', 'privmsg', $who, 'help           show this help');
   }
   if ($msg =~ /die/) {
      my $quitmsg = 'Terminated by '.$who;
      print "DIE msg received from".$who;
      print  "Terminating...\n";
      $kernel->post('blaster', 'quit', $quitmsg);
   } 
   if ($msg =~ /blast */) {
      my $victim;
      $msg =~ /^blast(.*)/;
      $victim = $1; 
      my $killmsg = 'KILL'.$victim.' '.$blastmsg;
      $kernel->post('blaster', 'sl', $killmsg);
      $kernel->post('blaster', 'privmsg', $who, 'Blasted '.$victim);
   }
}

POE::Component::IRC->new( 'blaster' ) or die "NOO! can't create IRC object :(\n";
POE::Session->new( 'main' => [qw(_start _stop irc_001 irc_376 irc_msg irc_353 irc_disconnected irc_socketerr 
 			         irc_ctcp_version irc_error)]);
$poe_kernel->run();

exit 0;


    
                    
                    
